* ======================================================================
*  FUNCNBOX.PRG   -  A toolchest of Functions created JUST FOR CLIPPER
*                    that will improve the speed at which you program
*                    by leaps and bounds!  It is a great box of repeated
*                    functions - just look!!!
*
*  FUNCTION      PARAMETERS                        RETURNS:
*  --------  ------------------------------  ------------------------------
*  BigBoxDT  (Msg)                           (.t.) --  use as a COMMAND
*  GetKey    (Msg,TestStr,Line)              a single key (STRING) char.
*  GetVar    (Msg,Length,PictureTmpl,Line)   a variable length STRING var
*  GetVarD   (Msg,Memvar,PictureTmpl,Line)   like GETVAR, w/ a default.
*  PrtMsg    (Msg,Line)                      (.t.) --  use as a COMMAND
*  LinBoxK   (Msg,TestStr,Line)              a single key (STRING) char.
*  LinBoxV   (Msg,Length,PictureTmpl,Line)   a variable length STRING var
*  LinBoxM   (Msg,Line)                      (.t.) --  use as a COMMAND
*  BoxClear  (Linecount,NumOfLines)          (.t.) --  use as a COMMAND
*  GetMonth  (adate)                         a charstring of the MONTH
*  DspClock  (chars,lineclock)               a single key (STRING) char.
*  DspField  (FldName,StartRow,NumofRows,    (.t.) --  use as a COMMAND--
*             DispNums)                      display a field of a DBF in box.
*  DspArray  (ArrayName,StartRow,NumofRows,  (.t.) --  use as a COMMAND--
*             Width,DispNums)                display elements of array in box.
*  MemoPrt   (MemofldName,LineLength)        sends Memo Field to the printer.
*  PadZeroL  (Anumber,TotSpaces)             left-pads a num or str with zeros
*  PadZeroR  (Anumber,TotSpaces)             right-pads a num or str with zeros
*  Justify   (Item,TotSpaces,LftCtrRite)     a function that pads data w/spaces
*  ScrnDisp  (Scrnfile,scrnname,box?)        (.t.) --  use as a COMMAND
*  Window    (TC,LS,BC,RS,boxchars)          (.t.) - draws a window/box!
*  WordProc  (Str,NumLnes,LinLen,BreakChrs)  (.t.) - psuedo word proc'g
*  MakeText  (filename,textlength)           (.t.) - use as a COMMAND
*  MemoPrt   (Memofldnam,linelength)         send Memofield to printer.
*  AmPm      (time)         (in EXTEND.LIB)  a time-string in AM/PM format
*  Mod       (Num1,Num2)    (in EXTEND.LIB)  REMAINDER of Num1/Num2
* ---------------------------------------------------------------------
* DisplayLin is, by default, 23.  However, u can change it temporarily
*            via FOR/NEXT or do/while loops to get it to do iterative
*            displays, gets, etc!!!
* Remember:  GetKey, GetVar, LinBoxK, LinBoxV will all default the
*            GETs line to whatever the value is for DisplayLin IF
*            the parameter is not EXPRESSLY passed!
* ---------------------------------------------------------------------







* BigBoxDT(message) - a function that accepts 1 parameter:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*   C   -  "message" is any string of length of 55 or less
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : BlankScrn, C  -  a string (len = 4000)
*                             that has been made from a blank screen
*                             and saved to this memvar.  Speeds entire
*                             screen clearing DRAMATICALLY!
* ---------------------------------------------------------------------
*
* Purpose :  Just like the "DO BIGBOXDT" of stokrout.obj yore...
*
* ---------------------------------------------------------------------
FUNCTION BIGBOXDT
PRIVATE message
PARAMETERS message
*
*
*
if len(message) > 55
   message=substr(message,1,55)
endif
restore screen from BlankScrn
set color to
@ 1,0 to 24,79 DOUBLE
@ 3,0 say chr(204)
@ 3,1 say replicate(chr(205),78)
@ 3,79 say chr(185)
set color to w+
@ 2,(80-len(message))/2 say message
set color to
@ 2,3 say date()
@ 2,67 say ampm(time())
RETURN  (.t.)




* ---------------------------------------------------------------------
* GetKey(message,okchars,linn) - a function that accepts 3 parameters:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*   C   -  "message" is any string of length of 77 or less
*   C,L -  "okchars" is any string of characters for VALID purposes.
*                    HOWEVER, if okchars is any logic variable, then
*                    then ANY CHARACTER is acceptable.
*   N   -  "linn"    is the line number where prompt appears
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DisplayLin, N  -  what line to disp msg!
* ---------------------------------------------------------------------
* Purpose :  GETKEY() centers, and prints a message in highlight
*            on a specified line.  It then GETs a key, and then
*            validates it against those in the OKCHARS list.
*            It keeps the GET active until the proper key list range
*            is satisfied.
*            BECAUSE of the flexibility of the definition, GETKEY can:
*            1) Print a msg, wait for any KEY:  GetKey(msg)
*            2) Print a msg, wait for SEL KEY:  GetKey(msg,KEYS)
*            3) Print a msg, wait for SEL KEY:  GetKey(msg,KEYS,line)
* ---------------------------------------------------------------------
FUNCTION GETKEY
PRIVATE message,okchars,linn,sglkey
PARAMETERS message,okchars,linn
*
*
*
if type("linn")<>"N"
   linn=DisplayLin
endif
if type("okchars")<>"C"
   if type("okchars")="N"
      linn=okchars
   endif
   okchars=.f.
endif

if linn=0
   linn=1
endif
sglkey=" "
clear gets
if len(message) > 77
   message=substr(message,1,77)
endif
@ linn,1 say space(78)
set color to w+
set cursor ON
if type("okchars")="L"
   @ linn,(80-len(message))/2 say message GET sglkey
  ELSE
   @ linn,(80-len(message))/2 say message GET sglkey pict "!" ;
     valid (sglkey $ upper(okchars))
endif
read
clear gets
set cursor OFF
set color to
@ linn,1 say space(78)
if type ("okchars")="L"
   return (.t.)
endif
RETURN (sglkey)



* ---------------------------------------------------------------------
* GetVar(message,lenth,pixtmpl,Linn) - a function that accepts 4
*                                     parameters:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*  C  -  "message" is any string of length of 77 or less
*  N  -  "lenth  " is the length of the variable
*  C  -  "pixtmpl " is the picture template - a string
*  N  -  "linn"    is line number of prompt
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DisplayLin, N  -  what line to disp msg!
* ---------------------------------------------------------------------
*
* Purpose :  GETVAR() centers, and prints a message in highlight
*            on a specified line.  It then GETs a memory variable and
*            validates it against the picture template.
*            This function gets STRINGS ONLY!!!!
*
* ---------------------------------------------------------------------
FUNCTION GETVAR
PRIVATE message,lenth,pixtmpl,linn,Mvar,messag,totlen
PARAMETERS message,lenth,pixtmpl,linn
*
*
if type("linn")<>"N"
   linn=DisplayLin
endif
if type("pixtmpl")<>"C"
   if type("pixtmpl")="N"
      linn=pixtmpl
   endif
   pixtmpl=.f.
endif
*
if linn=0
   linn=1
endif
totlen=len(message)+lenth+2
do while totlen>77
   message=substr(message,1,len(message)-1)
   totlen=totlen-1
enddo
Mvar=space(lenth)
set color to
@ linn,1 say space(78)
set color to w+
@ linn,(80-totlen)/2 say message
set color to
clear gets
set confirm on
set cursor ON
if type("pixtmpl")<>"C"
   @ linn,col()+2 get Mvar
 else
   @ linn,col()+2 get Mvar pict "&pixtmpl"
endif
read
clear gets
set cursor OFF
set confirm off
@ linn,1 say space(78)
RETURN (Mvar)




* ---------------------------------------------------------------------
* GetVarD(message,Memvar,pixtmpl,Linn) - a function that accepts 4
*                                        parameters:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*  C  -  "message" is any string of length of 77 or less
*  *  -  "Memvar " is the default variable passed to the function
*  C  -  "pixtmpl" is the picture template - a string.  YOU MUST PASS
*                  THIS PARAMETER!
*  N  -  "linn   " is line number of prompt
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DisplayLin, N  -  what line to disp msg!
* ---------------------------------------------------------------------
*
* Purpose :  GETVARD() centers, and prints a message in highlight
*            on a specified line.  It then GETs a memory variable and
*            validates it against the picture template, using
*            the Memvar passed to it as a default.
* ---------------------------------------------------------------------
FUNCTION GETVARD
PRIVATE message,lenth,pixtmpl,linn,Mvar,messag,totlen
PARAMETERS message,Memvar,pixtmpl,linn
*
*
if type("linn")<>"N"
   linn=DisplayLin
endif

do case
   case type("Memvar")="N"
        lenth=len(alltrim(str(Memvar)))
   case type("Memvar")="C"
        lenth=len(Memvar)
   case type("Memvar")="D"
        lenth=8
   case type("Memvar")="L"
        lenth=1
endcase
*
*
if linn=0
   linn=1
endif
totlen=len(message)+lenth+2
do while totlen>77
   message=substr(message,1,len(message)-1)
   totlen=totlen-1
enddo

Mvar=Memvar

set color to
@ linn,1 say space(78)
set color to w+
@ linn,(80-totlen)/2 say message
set color to
clear gets
set confirm on
set cursor ON
@ linn,col()+2 get Mvar pict "&pixtmpl"
read
clear gets
set cursor OFF
set confirm off
@ linn,1 say space(78)
RETURN (Mvar)




* ---------------------------------------------------------------------
* PrtMsg(message,linn) - a function that accepts 2 parameters:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*   C   -  "message" is any string of length of 77 or less
*   N   -  "linn   " is the line to display the message
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DisplayLin, N  -  what line to disp msg!
* ---------------------------------------------------------------------
*
* Purpose :  Just like the "DO PRTMSG23" of stokrout.obj yore...
*            except that it prints it on the specfied line.
*            IF NO LINE IS SPECIFIED, it defaults to DISPLAYLIN
*            ( & ENVIRNMT defaults DISPLAYLIN to 23)
* ---------------------------------------------------------------------
FUNCTION PRTMSG
PRIVATE message,linn
PARAMETERS message,linn
*
*
*
if type("linn")<>"N"
   linn=DisplayLin
endif
if linn=0
   linn=1
endif
if len(message) > 77
   message=substr(message,1,77)
endif
@ linn,1 say space(78)
set color to w+
@ linn,(80-len(message))/2 say message
set color to
RETURN (.t.)





* ---------------------------------------------------------------------
* LinBoxK(message,okchars,linn) - a function that accepts 3 parameters:
*
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*   C   -  "message" is any string of length of 75 or less
*   C,L -  "okchars" is any string of characters for VALID purposes.
*                    HOWEVER, if okchars is any logic variable, then
*                    then ANY CHARACTER is acceptable.
*   N   -  "linn"    is line number of prompt
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DisplayLin, N  -  what line to disp msg!
* ---------------------------------------------------------------------
*
*  Purpose :         LINBOXK is just like GetKey() except that it
*                    calcs where the msg and key prompt begins and ends
*                    and draws a double lined box around it!
*
* ---------------------------------------------------------------------
FUNCTION LINBOXK
PRIVATE message,okchars,linn,sglkey,leftcorner,ritecorner,messag
PARAMETERS message,okchars,linn
*
*
*
if type("linn")<>"N"
   linn=DisplayLin
endif
if type("okchars")<>"C"
   if type("okchars")="N"
      linn=okchars
   endif
   okchars=.f.
endif
if linn=0
   linn=1
endif
sglkey=" "
if len(message) > 73
   message=substr(message,1,73)
endif
messag=message+space(2)
leftcorner=(80-len(messag))/2
ritecorner=leftcorner+len(messag)
if ritecorner>77
   ritecorner=77
endif
@ linn-1,1 say space(78)
@ linn,1 say space(78)
@ linn+1,1 say space(78)
set color to
@ linn-1,leftcorner-2 to linn+1,ritecorner+2 DOUBLE
@ linn,leftcorner-1 say space(len(messag)+3)
set color to w+
clear gets
@ linn,leftcorner say message
set cursor ON
if type("okchars")="L"
   @ linn,col()+2 GET sglkey
  ELSE
   @ linn,col()+2 GET sglkey pict "!" valid (sglkey $ upper(okchars))
endif
read
clear gets
set cursor OFF
if type ("okchars")="L"
   sglkey=.t.
endif
set color to
@ linn-1,1 say space(78)
@ linn,1 say space(78)
@ linn+1,1 say space(78)
RETURN (sglkey)



* -------------------------------------------------------------------------
* LinBoxV(message,lenth,pixtmpl,linn) - a function that takes 4 parameters:
*
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*   C   -  "message" is any string of length of 75 or less
*   N   -  "lenth  " is the length of the Mvar to GET.
*   C   -  "pixtmpl" is a string - picture template
*   N   -  "linn"    is line number of prompt
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DisplayLin, N  -  what line to disp msg!
* ---------------------------------------------------------------------
*
*  Purpose :         LINBOXV is just like GetVar() except that it
*                    calcs where the msg and key prompt begins and ends
*                    and draws a double lined box around it!
*
* ---------------------------------------------------------------------
FUNCTION LINBOXV
PRIVATE message,lenth,pixtmpl,linn,leftcorner,ritecorner,messag,Mvar,totlen
PARAMETERS message,lenth,pixtmpl,linn
*
*
*
*
if type("linn")<>"N"
   linn=DisplayLin
endif
if type("pixtmpl")<>"C"
   if type("pixtmpl")="N"
      linn=pixtmpl
   endif
   pixtmpl=.f.
endif
if linn=0
   linn=1
endif
totlen=len(message)+lenth+2
do while totlen>75
   message=substr(message,1,len(message)-1)
   totlen=totlen-1
enddo
Mvar=space(lenth)
leftcorner=(80-totlen)/2
ritecorner=leftcorner+totlen
if ritecorner>77
   ritecorner=77
endif
@ linn-1,1 say space(78)
@ linn,1 say space(78)
@ linn+1,1 say space(78)
set color to
@ linn-1,leftcorner-2 to linn+1,ritecorner+2 DOUBLE
@ linn,leftcorner-1 say space(totlen+3)
set color to w+
@ linn,leftcorner say message
set color to
clear gets
set confirm on
set cursor ON
if type("pixtmpl")<>"C"
   @ linn,col()+3 get Mvar
 else
   @ linn,col()+3 get Mvar pict "&pixtmpl"
endif
read
clear gets
set cursor OFF
set confirm off
Mvar=trim(Mvar)
@ linn-1,1 say space(78)
@ linn,1 say space(78)
@ linn+1,1 say space(78)
set color to
RETURN (Mvar)


* ---------------------------------------------------------------------
* LinBoxM(message,linn) - a function that accepts 2 parameters:
*
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*   C   -  "message" is any string of length of 75 or less
*   N   -  "linn"    is line number of prompt
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DisplayLin, N  -  what line to disp msg!
* ---------------------------------------------------------------------
*
*  Purpose :         LINBOXM is just like GetKey() except that it
*                    calcs where the msg and key prompt begins and ends
*                    and draws a double lined box around it!
*
* ---------------------------------------------------------------------
FUNCTION LINBOXM
PRIVATE message,linn,leftcorner,ritecorner
PARAMETERS message,linn
*
*
*
if type("linn")<>"N"
   linn=DisplayLin
endif
*
if linn=0
   linn=1
endif
if len(message) > 75
   message=substr(message,1,75)
endif
leftcorner=(80-len(message))/2
ritecorner=leftcorner+len(message)
if ritecorner>77
   ritecorner=77
endif
@ linn-1,1 say space(78)
@ linn,1 say space(78)
@ linn+1,1 say space(78)
set color to
@ linn-1,leftcorner-2 to linn+1,ritecorner+2 DOUBLE
@ linn,leftcorner-1 say space(len(message)+3)
set color to w+
@ linn,leftcorner say message
set color to
RETURN (.t.)




* ---------------------------------------------------------------------
* BoxClear(linncount,NumOfLines) - a function that accepts 2 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  N  -  "linncount "  is the start of the line to "clear out the box"
*  N  -  "NumOfLines"  is the number of subsequent lines to clear.
*
*  Purpose :         BoxClear puts spaces inside the perimeter of the
*                    box, and does not erase the box.  It keeps info
*                    in the box looking tidy!
*
* ---------------------------------------------------------------------
FUNCTION BOXCLEAR
PRIVATE linncount,linn
PARAMETERS linncount,NumOfLines
*
if linncount>23
   linncount=23
endif
if type("NumOfLines")<>"N"
   for linn=linncount to 23
       @ linn,1 say space(78)
   next linn
 ELSE
   do while linncount+NumOfLines>23
      NumOfLines=NumOfLines-1
   enddo
   for linn=0 to NumOfLines-1
       @ linncount+linn,1 say space(78)
   next linn
endif
*
RETURN (.t.)



* ---------------------------------------------------------------------
* GetMonth(adate)                - a function that accepts 1 param:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  C,D-  "adate     "  is a date of character type OR date type
*                      IF NO PARAMS OR INVALID PARAMS ARE PASSED, then
*                      return the name of the month of the system date.
*
*  Purpose :           To return a character STRING of the NAME of the
*                      month param passed.
*
* ---------------------------------------------------------------------
FUNCTION GETMONTH
PRIVATE adate,date1,monthstr,tmonth,monthstr
PARAMETERS adate
*
*
do case
   case type("adate")="U" .or. type("adate")="N"
        adate=date()
   case type("adate")="C"
        if dtoc(ctod(adate))="  /  /  "
           adate=date()
          ELSE
           adate=ctod(adate)
        endif
   case type("adate")="D"
        if dtoc(adate)="  /  /  "
           adate=date()
        endif
endcase

monthstr="January  February March    April    May      June     July     August   SeptemberOctober  November December "
Tmonth=substr(monthstr,(month(adate)-1)*9+1,9)
release monthstr
return (alltrim(Tmonth))



* ---------------------------------------------------------------------
* DspClock(chars,lineclock) - a function that needs 2 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  C  -  "chars "  is the acceptable character string list to use
*  N  -  "lineclock" is the line number at which to display the clock.
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : ClockLine, N  -  what line to disp clock!
* ---------------------------------------------------------------------
*
*  Purpose :         DspClock puts the current time at the usual place
*                    at the second line of the box.  It waits for a
*                    key, and if CHARS is a passed parameter, it will
*                    wait until one of the keys in the list is pressed
* ---------------------------------------------------------------------
FUNCTION DSPCLOCK
PRIVATE chars,lineclock,Minkey,Mtime
PARAMETERS chars,lineclock
*
clear typeahead
if type("lineclock")<>"N"
   lineclock=clockline
endif
DO WHILE .t.
   Minkey=0
   @ lineclock,67 say ampm(time())
   Mtime=time()
   do while Mtime=time() .and. Minkey=0
      Minkey=inkey()
   enddo
   if Minkey<>0
      if type("CHARS")<>"C"
         exit
      endif
      * ------------------
      * UPPERFY your inkey
      * ------------------
      if Minkey>96 .and. Minkey<123
         Minkey=Minkey-32
      endif
      if at(chr(Minkey),chars)>0
         exit
      endif
   endif
enddo
RETURN  (chr(Minkey))




* --------------------------------------------------------------------------
* DspField(FldName,StartRow,NumOfRows,DispNums) - a function that
*                                                       accepts 4 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  C  -  "FldName   "  is the field to be displayed in the box.
*  N  -  "StartRow  "  is the Row at which to start the display of fields
*  N  -  "NumOfRows "  is the number of display rows to display.
*  L  -  "DispNums  "  determines whether or not to display sequential
*                      numbers next to the fields or not, starting with 1.
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : PressKey, C  -  a message string telling
*                             the user to press any key to resume.
* ---------------------------------------------------------------------
*
*  Purpose :           DspField() attempts to display all the records
*                      of a field within a box.  IN ORDER FOR THE FUNCTION
*                      TO WORK A FILE MUST BE OPEN!
*                      ALSO, the width is determined by the function!
* ---------------------------------------------------------------------
FUNCTION DSPFIELD
PRIVATE FldName,StartRow,NumOfRows,DispNums,Lenth,lc,RcolPointr,NcolPointr
PRIVATE ItemNum
PARAMETERS FldName,StartRow,NumOfRows,DispNums
*
*
*
*

if ""=trim(upper(alias())) .or. StartRow>23
   return (.f.)
endif

if type("DispNums")<>"L"
   DispNums=.f.
endif

do while (StartRow+NumOfRows)>23
   NumOfRows=NumOfRows-1
enddo


* ------------------------------------
* Use this routine below if u can find
* out a way to get length of fieldname
* that's NUMERIC!!  YOU DID!!!!
* ------------------------------------
do case
   case type("&FldName")="N"
        lenth=len(substr(str(&FldName),RAT(".",str(&FldName))+1))
   case type("&FldName")="C"
        lenth=len(&FldName)
   case type("&FldName")="D"
        lenth=8
   case type("&FldName")="L"
        lenth=3
   otherwise
        * ------------------------------
        * if MEMO or ARRAY type, sorry.
        * ------------------------------
        return (.f.)
endcase

if lenth>77
   lenth=77
endif

Lenth=Lenth+1
ItemNum=1


lc=StartRow
Rcolpointr=2
if DispNums
   Ncolpointr=Rcolpointr+5
  else
   Ncolpointr=Rcolpointr
endif
do while .not. eof()
   if DispNums
      set color to w+
      @ lc,Rcolpointr say str(ItemNum,4,0)+"-"
      set color to
   endif
   @ lc,Ncolpointr get &Fldname
   clear gets
   ItemNum=ItemNum+1
   lc=lc+1
   if lc>NumOfRows+StartRow-1
      lc=StartRow
      Rcolpointr=Rcolpointr+lenth
      if DispNums
         Rcolpointr=Rcolpointr+5
         Ncolpointr=Rcolpointr+5
        ELSE
         Ncolpointr=Rcolpointr
      endif
      if Ncolpointr+lenth>78
         GetKey("There are more items to display!  &PressKey")
         boxclear(StartRow)
         Rcolpointr=2
         if DispNums
            Ncolpointr=Rcolpointr+5
           else
            Ncolpointr=Rcolpointr
         endif
      endif
   endif
   skip
enddo


RETURN (.t.)





* --------------------------------------------------------------------------
* DspArray(ArrayName,StartRow,NumOfRows,Width,DispNums) - a function that
*                                                       accepts 5 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  C  -  "ArrayName "  is the array elements to be displayed in the box.
*  N  -  "StartRow  "  is the Row at which to start the display of fields
*  N  -  "NumOfRows "  is the number of display rows to display.
*  N  -  "Width     "  is the width of the field - need esp. for ARRAYS!
*                      since u can pass multiple data types in one array!
*  L  -  "DispNums  "  determines whether or not to display sequential
*                      numbers next to the fields or not, starting with 1.
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : PressKey, C  -  a message string telling
*                             the user to press any key to resume.
* ---------------------------------------------------------------------
*
*  Purpose :           DspArray() attempts to display all the elements
*                      of an array within a box.
* ---------------------------------------------------------------------
FUNCTION DSPARRAY
PRIVATE ArrayName,StartRow,NumOfRows,Width,DispNums,Lenth,i,lc
PRIVATE NcolPointr,RcolPointr,NumElmnts
PARAMETERS ArrayName,StartRow,NumOfRows,Width,DispNums
*
*
*
*

if type("ArrayName")<>"A" .or. StartRow>23
   return (.f.)
endif

if type("DispNums")<>"L"
   DispNums=.f.
endif

do while (StartRow+NumOfRows)>23
   NumOfRows=NumOfRows-1
enddo

if Width>77
   Width=77
endif


Lenth=Width+1
NumElemnts=len(ArrayName)


lc=StartRow
Rcolpointr=2
if DispNums
   Ncolpointr=Rcolpointr+5
  else
   Ncolpointr=Rcolpointr
endif
for i=1 to NumElemnts
   if DispNums
      set color to w+
      @ lc,Rcolpointr say str(i,4,0)+"-"
      set color to
   endif
   if type("ArrayName[i]")<>"U"
      @ lc,Ncolpointr get ArrayName[i]
      lc=lc+1
   endif
   clear gets
   if lc>NumOfRows+StartRow-1
      lc=StartRow
      Rcolpointr=Rcolpointr+lenth
      if DispNums
         Rcolpointr=Rcolpointr+5
         Ncolpointr=Rcolpointr+5
        ELSE
         Ncolpointr=Rcolpointr
      endif
      if Ncolpointr+lenth>78
         GetKey("There are more items to display!  &PressKey")
         boxclear(StartRow)
         Rcolpointr=2
         if DispNums
            Ncolpointr=Rcolpointr+5
           else
            Ncolpointr=Rcolpointr
         endif
      endif
   endif
next i


RETURN (.t.)



* --------------------------------------------------------------------------
* PadZeroL(Anumber,TotSpaces) - a function that accepts 2 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
* N,C -  "Anumber   "  is a number OR a string to be padded with zeroes.
*  N  -  "TotSpaces "  is the total length of the string to be passed back.
*
*  Purpose :           PadZeroL takes a number or a string and pads it with
*                      zeroes at the left of the string, to a total width
*                      of TotSpaces.  The completed string is return value.
* ---------------------------------------------------------------------
FUNCTION PADZEROL
PRIVATE Anumber,TotSpaces
PARAMETERS Anumber,TotSpaces

if type("TotSpaces")<>"N"
   TotSpaces=1
endif

if type("ANUMBER")="L" .or. type("ANUMBER")="M" .or. type("ANUMBER")="D"
   RETURN (space(TotSpaces))
endif
if type("Anumber")="N"
   Anumber=alltrim(str(Anumber))
  ELSE
   Anumber=alltrim(Anumber)
endif

if len(Anumber) > TotSpaces
   RETURN(replicate("*",TotSpaces))
endif

RETURN ( replicate("0",TotSpaces-Len(Anumber)) + Anumber )



* --------------------------------------------------------------------------
* PadZeroR(Anumber,TotSpaces) - a function that accepts 2 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
* N,C -  "Anumber   "  is a number OR a string to be padded with zeroes.
*  N  -  "TotSpaces "  is the total length of the string to be passed back.
*
*  Purpose :           PadZeroR takes a number or a string and pads it with
*                      zeroes at the right of the string, to a total width
*                      of TotSpaces.  The completed string is return value.
* -------------------------------------------------------------------------
FUNCTION PADZEROR
PRIVATE Anumber,TotSpaces
PARAMETERS Anumber,TotSpaces

if type("TotSpaces")<>"N"
   TotSpaces=5
endif

if type("ANUMBER")="L" .or. type("ANUMBER")="M" .or. type("ANUMBER")="D"
   RETURN (space(TotSpaces))
endif
if type("Anumber")="N"
   Anumber=alltrim(str(Anumber))
  ELSE
   Anumber=alltrim(Anumber)
endif

if len(Anumber) > TotSpaces
   RETURN(replicate("*",TotSpaces))
endif

RETURN ( Anumber + replicate("0",TotSpaces-Len(Anumber)) )



* --------------------------------------------------------------------------
* Justify(Item,TotSpaces,LftRiteCtr) - a function that accepts 3 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*  N,C,D,M - "Item      "  is any data type to be "padded" with spaces.
*  N       - "TotSpaces "  is the total length of the string to be RETURN'd.
*  C       - "LftRiteCtr"  determines if justification is LEFT, RIGHT or
*                          CENTER.
*
*  Purpose :           This function is useful for absolute formatting of
*                      paper or screen pages; it also useful for exporting
*                      SET ALTERNATE ascii files, w/fields of fixed length.
* --------------------------------------------------------------------------
FUNCTION JUSTIFY
PARAMETERS Item,TotSpaces,LftRiteCtr
PRIVATE    Item,TotSpaces,LftRiteCtr, LeftSpace, RightSpace, Itemhold

* -------------------------------------------------------------------
* Make sure u know whether or not to pad (justify) left or right. If
* not defined, or not "R" nor "L", left justify it.
* -------------------------------------------------------------------
if type("LftRiteCtr")<>"C"
   LftRiteCtr="L"
  else
   If at(LftRiteCtr,"LRC") = 0
      LftRiteCtr="L"
   endif
endif

if type("TotSpaces")<>"N"
   TotSpaces=5
endif

* ---------------------------------------------
* WHATEVER data type ITEM is, convert to STRING
* ---------------------------------------------
do case
   case type("Item")="L"
        iif(item,item="YES",item="NO")
   case type("Item")="D"
        item=dtoc(item)
   case type("Item")="M"
        if len(item) > TotSpaces
           item=substr(item,1,len(TotSpaces))
        endif
   case type("Item")="N"
        item = alltrim(str(item))
   case type("Item")="C"
        item = alltrim(item)
endcase

if len(Item) > TotSpaces .or. type("item")="U"
   RETURN(replicate("*",TotSpaces))
endif

DO CASE
   CASE LftRiteCtr="L"
        RETURN ( Item + replicate(" ",TotSpaces-Len(Item)) )
   CASE LftRiteCtr="R"
        RETURN ( replicate(" ",TotSpaces-Len(Item)) + Item )
   CASE LftRiteCtr="C"
        LeftSpaces=int((TotSpaces-len(item))/2)
        RightSpaces=TotSpaces - ( LeftSpaces + len(item) )
        RETURN ( space(LeftSpaces) + item + space(RightSpaces) )
endcase


RETURN ( .t. )





* ---------------------------------------------------------------------
* Window(TC,LS,BC,RS,boxchars) - a function that accepts 5 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  N  -  "topcorner "  is the start of the TOP CORNER    of the box
*  N  -  "leftside  "  is the start of the LEFT SIDE     of the box"
*  N  -  "bottcorner"  is the start of the BOTTOM CORNER of the box"
*  N  -  "rightside "  is the start of the RIGHT SIDE    of the box"
*  C  -  "boxcarz   "  is the "picture template chr$ of the box's edges
*                      ANY FILL CHARACTERS (options)  MUST BE INCLUDED
*                      in this parameter!!!
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : DblFrame, C  -  what constitutes the box!
* ---------------------------------------------------------------------
*  Purpose :           Draw a box or window on the screen, and (if the
*                      option character is specified) put a fill char
*                      inside it.
*
* ---------------------------------------------------------------------
FUNCTION Window
PRIVATE topcorner,leftside,bottcorner,rightside,boxcarz
PARAMETERS topcorner,leftside,bottcorner,rightside,boxcarz
if type("boxcarz")<>"C"
   boxcarz=DblFrame
endif
*
@ topcorner,leftside,bottcorner,rightside BOX boxcarz
*
RETURN (.t.)





* ------------------------------------------------------------------
* SCRNDISP - a FUNCTION that allows u to find
*            a screen in a screenfile.DBF and then flash it onto the
*            screen. 3 parameters are passed:
*
* Scrn_File - the name of the file that contains the screens.
* PageName  - the name of the individual screen to be "seeked"
* MakeBox   - logic variable - do u need to draw a double box around
*            the screen?  If it was done by FLASHUP, you do!
* --------------------------------------------------------------------
FUNCTION SCRNDISP
PRIVATE Scrn_File,PageName,Makebox,indexfile,indexok,FileWuzOpen,Workarea
PARAMETERS Scrn_File,PageName,Makebox

if type("MakeBox")<>"L"
   MakeBox=.f.
endif

indexfile=upper(Scrn_File)+".NTX"

if file ("&indexfile")
   indexok=.t.
  else
   indexok=.f.
endif
* -----------------------------------
* If screen file ain't open, OPEN IT!
* -----------------------------------
FileWuzOpen=.t.
workarea=select()
if upper(alias()) <> upper(Scrn_File)
   select 0
   use &ScrnFile
   go top
   FileWuzOpen=.f.
endif

if indexok
   set index to &Scrn_file
   go top
   seek upper(PageName)
 else
   locate for upper(scrnname)=upper(PageName)
endif

if .not. eof()
   xxx=scrnimage
   restore screen from xxx
   if MakeBox
      @ 1,0 to 24,79 DOUBLE
   endif
   release xxx
endif

if .not. FileWuzOpen
   use
   select (workarea)
endif

RETURN (.t.)



* ---------------------------------------------------------------------
* WordProc(String,NumLines,LineLength,BreakChars) - a function that
*                                                   accepts 4 params:
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  C  -  "String    "  is the string to be "word processed"
*  N  -  "NumLines  "  is the Number of Lines to break the string into
*  N  -  "LineLength"  is the maximum length of each line
*  C  -  "BreakChars"  is the characters the function will attempt to
*                      count as a suitable "break" or wordwrap point.
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : NONE.  However, WORDPROC[] array will
*                             be PUBLIC'ed after execution of this
*                             routine so that the calling program can
*                             access it as necessary
* ---------------------------------------------------------------------
*  Purpose :           WordProc() attempts to break up those
*                      lines of text into desired lengths in a desired
*                      number of lines.  Pseudo-wordprocessing.
*
* ---------------------------------------------------------------------
FUNCTION WORDPROC
PRIVATE String,NumLines,LineLength,BreakChars,LinesCt,TextStr,position
PARAMETERS String,NumLines,LineLength,BreakChars
*
*
*
*
if type("BreakChars")<>"C"
   BreakChars=" ;:,"
endif

* ---------------------------------------------------------
* Create the arrays to hold the TEXT STRINGS, and make them
* PUBLIC
* ---------------------------------------------------------
PUBLIC WordProc[NumLines]
AFILL(WordProc,space(LineLength))

* ---------------------------------------
* Now actually BEGIN the breaking down...
* ---------------------------------------
LinesCT=1
do while LinesCT<Numlines+1
   if len(String)>LineLength
      position=LineLength
      do while len(String)>0
         if at(substr(String,position,1),BreakChars)>0
            WordProc[LinesCT]=substr(String,1,position)
            String=substr(String,position+1)
            exit
         endif
         position=position-1
         if position=0
            WordProc[LinesCt]=substr(String,1,linelength-1)+"-"
            String=substr(String,Linelength)
            exit
         endif
      enddo
    else
      WordProc[LinesCt]=string
      exit
   endif
   LinesCT=LinesCT+1
enddo

RETURN (.t.)




* ---------------------------------------------------------------------
* MakeText(dumyfile,textlength)  -   a function that accepts 2 Params.
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  C  -  "Dumyfile  "  is the name of the dummy file to create.
*  N  -  "TextLength"  is the Number of chars for each record
*
*
*  Purpose :        Maketext() creates a "DUMMY" textfile.dbf. Any copy
*                   of it is WRITTEN OVER, so that is consistent
*                   with the convention of 1 field, called "TEXT", type
*                   is CHAR, with a LEN of TEXTLENGTH.  If this param
*                   is not passed, it is assumed to be 82.
*                   DATABASES ARE CLOSED WITH THIS FUNCTION!  MAKE SURE
*                   that NO DBF is OPEN at the time you call this !!!
* ---------------------------------------------------------------------
FUNCTION MAKETEXT
PRIVATE dumyfile,textlength
PARAMETERS dumyfile,textlength


close databases
if at(".",dumyfile)=0
   dumyfile=upper(dumyfile)+".DBF"
endif
if file ("&dumyfile")
   erase &dumyfile
endif
if type("TEXTLENGTH")<>"N"
   textlength=82
endif

CREATE ZXZXZX.DBF
USE ZXZXZX.DBF
ZAP
append blank
REPL field_name WITH "TEXT"
REPL field_type WITH "C"
REPL field_len  WITH textlength
REPL field_dec  WITH 0
use
create &dumyfile from zxzxzx.dbf
erase zxzxzx.dbf

RETURN (.t.)




* ---------------------------------------------------------------------
* MemoPrt(Memofldnam,linelength)  -   a function that accepts 2 Params.
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*  C  -  "MemoFldNam"  is the name of a memofield
*  N  -  "LineLength"  is the Number of chars for each line
*
* ---------------------------------------------------------------------
* GLOBAL VARIABLES required : TrnPrtrOn, C  -  a message string telling
*                             the user to turn the printer on.
*                             PressKey, C - a message string telling
*                             the user to press any key to resume.
* ---------------------------------------------------------------------
*
*  Purpose :        MemoPrt() formats a memofield and sends it to the
*                   printer.
* ---------------------------------------------------------------------
FUNCTION MemoPrt
PRIVATE MemoFldNam,LineLength,Pagelength,PageNum,lc,line,lines,prntline
PARAMETERS MemoFldNam,LineLength
* --------------------------------------
* This Function prints out a memofield.
* --------------------------------------
if type("LineLength")<>"N"
   LineLength=70
endif
if type("&MemoFldNam")<>"M"
   GetKey("&MemoFldNam is NOT a MEMO FIELD.  &Presskey")
   RETURN (.t.)
endif

PrtMsg("Now printing out the NOTEPAD.  Please wait.",24)
do while .not. isprinter()
   GetKey(TrnPrtrOn)
enddo
set console OFF
SET DEVICE TO PRINT
PageLength=57
PageNum=1
lc=5

lines=mlcount(&MemoFldNam,LineLength)

for line=1 to lines
    if lc>PageLength
       PageNum=PageNum+1
       @ 2,68 say "Page "+alltrim(str(PageNum))
       lc=5
    endif
    prntline=MemoLine(&MemoFldNam,LineLength,line)
    @ lc,int((80-LineLength)/2) say prntline
    lc=lc+1
next line

EJECT
set device to SCREEN
set console ON



RETURN (.t.)



* --------------------------------------------------------------
* AMPM - a function from the ExtendDB series that allows u to
*        print any given time in AM or PM format.
* --------------------------------------------------------------
FUNCTION AMPM
* Syntax: AMPM( <time string> )
* Return: An 11 byte character string with the time in a
*         12-hour am/pm format.
*
PARAMETERS cl_time
RETURN IF(        VAL(cl_time)<12, cl_time + " am",;
           IF(    VAL(cl_time)=12, cl_time + " pm",;
              STR(VAL(cl_time)-12,2) + SUBSTR(cl_time,3) + " pm" ) )




* ----------------------------------------------------------------------
* MOD(num1,num2) - a function from the ExtendDB series that allows u to
*                  get back a modulus REMAINDER from the qty num1/num2
* ----------------------------------------------------------------------
FUNCTION MOD
* Syntax: MOD( <expN1>, <expN2> )
* Return: The remainder of <expN1> divided by <expN2>
*
PRIVATE cl_result
PARAMETERS cl_num, cl_base
cl_result = cl_num % cl_base
RETURN IF( cl_base = 0, cl_num,;
           IF(cl_result * cl_base < 0, cl_result + cl_base, cl_result) )
